'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getWindow = require('get-window');

var _getWindow2 = _interopRequireDefault(_getWindow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Get the current selection's bounding rectangle for a given `window`.
 *
 * Modified from: https://github.com/bmcmahen/selection-position/blob/master/index.js
 *
 * @param {Window} window
 * @return {Object|Null}
 */

function getSelectionRect(selection) {
  if (!selection.rangeCount) return null;

  var range = selection.getRangeAt(0);
  if (!range.collapsed) return range.getBoundingClientRect();

  var window = (0, _getWindow2.default)(selection.anchorNode);
  var dummy = window.document.createElement('span');
  range.insertNode(dummy);
  var rect = dummy.getBoundingClientRect();
  dummy.parentNode.removeChild(dummy);
  return rect;
}

/**
 * Export.
 *
 * @type {Function}
 */

exports.default = getSelectionRect;